<?xml version="1.0" encoding="utf-8"?>
<!--
  ~ Copyright (C) 2023 The Android Open Source Project
  ~
  ~ Licensed under the Apache License, Version 2.0 (the "License");
  ~ you may not use this file except in compliance with the License.
  ~ You may obtain a copy of the License at
  ~
  ~      http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~ Unless required by applicable law or agreed to in writing, software
  ~ distributed under the License is distributed on an "AS IS" BASIS,
  ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  ~ See the License for the specific language governing permissions and
  ~ limitations under the License.
  -->
<configuration description="Config for multiuser cts tests instrumenting Sdk Sandbox process">
    <option name="test-suite-tag" value="cts" />
    <option name="config-descriptor:metadata" key="component" value="framework" />
    <option name="config-descriptor:metadata" key="parameter" value="not_instant_app" />
    <option name="config-descriptor:metadata" key="parameter" value="not_multi_abi" />
    <option name="config-descriptor:metadata" key="parameter" value="secondary_user" />

    <target_preparer class="com.android.tradefed.targetprep.RunOnSecondaryUserTargetPreparer">
        <option name="test-package-name" value="com.android.sdksandbox.tests.cts.inprocesstests" />
    </target_preparer>

    <!-- IMPORTANT: This needs to come before SuiteApkInstaller

       SuiteApkInstaller is not able to uninstall the Sdk-Provider.apk because the test
       app that requires it is still installed at that point. This means the apk would
       stay on the test device after the test ends.

       This preparer, during tear down, runs after SuiteApkInstaller and will finally
       uninstall the provider, leaving the device in a clean state.

       See b/314294893 for more details.
      -->
    <option name="test-user-token" value="%TEST_USER%" />
    <target_preparer
        class="com.android.tradefed.targetprep.RunCommandTargetPreparer">
        <option name="teardown-command"
            value="pm uninstall --user %TEST_USER% com.android.socketsdkprovider" />
    </target_preparer>

    <target_preparer class="com.android.tradefed.targetprep.suite.SuiteApkInstaller">
        <option name="cleanup-apks" value="true" />
        <option name="test-file-name" value="CtsSdkSandboxInprocessTests.apk" />
        <option name="test-file-name" value="SocketSdkProvider.apk" />
        <option name="test-file-name" value="SocketApp.apk" />
    </target_preparer>

    <target_preparer class="com.android.tradefed.targetprep.RunCommandTargetPreparer">
        <option name="run-command" value="svc power stayon true"/>
        <option name="run-command" value="cmd sdk_sandbox set-state --enabled" />
        <option name="run-command" value="device_config set_sync_disabled_for_tests persistent" />
        <option name="teardown-command" value="device_config set_sync_disabled_for_tests none" />
        <option name="teardown-command" value="cmd sdk_sandbox set-state --reset" />
        <option name="teardown-command" value="svc power stayon false" />
    </target_preparer>

    <test class="com.android.tradefed.testtype.AndroidJUnitTest">
        <option name="package" value="com.android.sdksandbox.tests.cts.inprocesstests" />
        <option name="instrument-sdk-sandbox" value="true" />
    </test>
    <object type="module_controller"
        class="com.android.tradefed.testtype.suite.module.MainlineTestModuleController">
        <option name="mainline-module-package-name" value="com.google.android.adservices" />
    </object>

    <option name="config-descriptor:metadata" key="mainline-param"
        value="com.google.android.adservices.apex" />
</configuration>
